//===================================================================
//	pas1000w.c
//
//	Copyright (C) P&A Technologies Inc.
//===================================================================
#define STRICT

#include <windows.h>
#include <tchar.h>

#include "pas1000w.h"


static HMODULE hDLL = NULL;

static FARPROC pPas1000Initialize;
static FARPROC pPas1000Create;
static FARPROC pPas1000Close;
static FARPROC pPas1000Terminate;
static FARPROC pPas1000GetVersion;
static FARPROC pPas1000GetDevInfo;
static FARPROC pPas1000SetUnitId;
static FARPROC pPas1000GetUnitInfo;
static FARPROC pPas1000SetTime;
static FARPROC pPas1000GetTime;
static FARPROC pPas1000SetMode;
static FARPROC pPas1000DigitalIn;
static FARPROC pPas1000DigitalOut;
static FARPROC pPas1000AlarmClear;
static FARPROC pPas1000StartLogging;
static FARPROC pPas1000StopLogging;
static FARPROC pPas1000GetStatus;
static FARPROC pPas1000GetChStatus;
static FARPROC pPas1000GetData;
static FARPROC pPas1000GetLastError;

static BOOL Pas1000wGetDllExportFunc( void );

//-------------------------------------------------------------------
// 		DLL[h(񃍁[h̓G[Ƃ)
// 		
// ߂l	 TRUE
//			s FALSE
//-------------------------------------------------------------------
BOOL Pas1000wDllOpen( void )
{
	if ( hDLL != NULL )
		return FALSE;

	hDLL = (HMODULE)LoadLibrary( PAS1000_DLL_NAME );
	if ( hDLL == NULL )
		return FALSE;

	if ( Pas1000wGetDllExportFunc() == FALSE ) {
		Pas1000wDllClose();								// DLLGNX|[g֐擾ɎŝDLLN[Y
		return FALSE;
	}
	return TRUE;
}
//-------------------------------------------------------------------
// 		DLLA[h(A[h̓G[Ƃ)
// 		
// ߂l	 TRUE
//			s FALSE
//-------------------------------------------------------------------
BOOL Pas1000wDllClose( void )
{
	if ( hDLL == NULL )
		return TRUE;

	if ( FreeLibrary( hDLL ) == TRUE ) {
		hDLL = NULL;
		return TRUE;
	}
	return FALSE;
}
//-------------------------------------------------------------------
// 		
// 		hWnd		DLLo郁bZ[W󂯎EBhẼnh
//	        uWMBase		o郁bZ[WID̃x[Xl
//			TimeOut		USB ]҂̃^CAEgԁB
// ߂l	 TRUE
//			s FALSE
//-------------------------------------------------------------------
BOOL Pas1000wInitialize( HWND hWnd, UINT uWMBase, SHORT TimeOut )
{
	if ( hDLL == NULL )
		return FALSE;

	return (*pPas1000Initialize)( hWnd, uWMBase, TimeOut );
}
//-------------------------------------------------------------------
// 		foCX̌
// 		pwDeviceNo	gpfoCX̃foCXʔԍi[̈ւ̃|C^
// ߂l	 TRUE
//			s FALSE
//-------------------------------------------------------------------
BOOL Pas1000wCreate( PWORD pwDeviceNo )
{
	if ( hDLL == NULL )
		return FALSE;

	return (*pPas1000Create)( pwDeviceNo );
}
//-------------------------------------------------------------------
// 		foCX̊J
// 		wDeviceNo	ΏۃfoCX̃foCXʔԍ
// ߂l	 TRUE
//			s FALSE
//-------------------------------------------------------------------
BOOL Pas1000wClose( WORD wDeviceNo )
{
	if ( hDLL == NULL )
		return FALSE;

	return (*pPas1000Close)( wDeviceNo );
}
//-------------------------------------------------------------------
// 		I
// 		
// ߂l	 TRUE
//			s FALSE
//-------------------------------------------------------------------
BOOL Pas1000wTerminate( void )
{
	if ( hDLL == NULL )
		return FALSE;

	return (*pPas1000Terminate)();
}
//-------------------------------------------------------------------
// 		o[W擾
// 		pdwDrvVer	hCõo[Wi[̈ւ̃|C^
//			pdwDllVer	DLL̃o[Wi[̈ւ̃|C^
// ߂l	 TRUE
//			s FALSE
//-------------------------------------------------------------------
BOOL Pas1000wGetVersion( PDWORD pdwDrvVer, PDWORD pdwDllVer )
{
	if ( hDLL == NULL )
		return FALSE;

	return (*pPas1000GetVersion)( pdwDrvVer, pdwDllVer );
}
//-------------------------------------------------------------------
// 		foCX擾
// 		wDeviceNo	ΏۃfoCX̃foCXʔԍ
//			pDevInfo	foCXi[\̂ւ̃|C^
// ߂l	 TRUE
//			s FALSE
//-------------------------------------------------------------------
BOOL Pas1000wGetDevInfo( WORD wDeviceNo, TDEVINFO *pDevInfo )
{
	if ( hDLL == NULL )
		return FALSE;

	return (*pPas1000GetDevInfo)( wDeviceNo, pDevInfo );
}
//-------------------------------------------------------------------
// 		jbgID̐ݒ
// 		wDeviceNo	ΏۃfoCX̃foCXʔԍ
//			dwUnitId	jbgIDԍ
// ߂l	 TRUE
//			s FALSE
//-------------------------------------------------------------------
BOOL Pas1000wSetUnitId( WORD wDeviceNo, DWORD dwUnitId )
{
	if ( hDLL == NULL )
		return FALSE;

	return (*pPas1000SetUnitId)( wDeviceNo, dwUnitId );
}
//-------------------------------------------------------------------
// 		jbg̎擾
// 		wDeviceNo	ΏۃfoCX̃foCXʔԍ
//			pdwUnitId	jbgIDi[̈ւ̃|C^
//			pdwNumCh	jbgɓڂĂAiO`li[̈ւ̃|C^
// ߂l	 TRUE
//			s FALSE
//-------------------------------------------------------------------
BOOL Pas1000wGetUnitInfo( WORD wDeviceNo, PDWORD pdwUnitId, PDWORD pdwNumCh )
{
	if ( hDLL == NULL )
		return FALSE;

	return (*pPas1000GetUnitInfo)( wDeviceNo, pdwUnitId, pdwNumCh );
}
//-------------------------------------------------------------------
// 		̐ݒ
// 		wDeviceNo	ΏۃfoCX̃foCXʔԍ
//			pdwHostTime	i[̈ւ̃|C^
// ߂l	 TRUE
//			s FALSE
//-------------------------------------------------------------------
BOOL Pas1000wSetTime( WORD wDeviceNo, PDWORD pdwHostTime )
{
	if ( hDLL == NULL )
		return FALSE;

	return (*pPas1000SetTime)( wDeviceNo, pdwHostTime );
}
//-------------------------------------------------------------------
// 		擾
// 		wDeviceNo		ΏۃfoCX̃foCXʔԍ
//			pdwFirmTime		t@[v̓i[̈ւ̃|C^
//			pdwFpgaTime		FPGAv̓i[̈ւ̃|C^
//			pdwAdjustStatus	AWXg̏Ԃi[̈ւ̃|C^
// ߂l	 TRUE
//			s FALSE
//-------------------------------------------------------------------
BOOL Pas1000wGetTime( WORD wDeviceNo, PDWORD pdwFirmTime,
						PDWORD pdwFpgaTime, PDWORD pdwAdjustStatus )
{
	if ( hDLL == NULL )
		return FALSE;

	return (*pPas1000GetTime)( wDeviceNo, pdwFirmTime, pdwFpgaTime, pdwAdjustStatus );
}
//-------------------------------------------------------------------
// 		샂[h̐ݒ
// 		wDeviceNo	ΏۃfoCX̃foCXʔԍ
//			pSetMode	ݒi[Ă\̂̃|C^
// ߂l	 TRUE
//			s FALSE
//-------------------------------------------------------------------
BOOL Pas1000wSetMode( WORD wDeviceNo, TSETMODE *pSetMode )
{
	if ( hDLL == NULL )
		return FALSE;

	return (*pPas1000SetMode)( wDeviceNo, pSetMode );
}
//-------------------------------------------------------------------
// 		fW^͂̓ǂݍ
// 		wDeviceNo			ΏۃfoCX̃foCXʔԍ
//			pbDigitalInValue	fW^͂i[̈ւ̃|C^
// ߂l	 TRUE
//			s FALSE
//-------------------------------------------------------------------
BOOL Pas1000wDigitalIn( WORD wDeviceNo, PBYTE pbDigitalInValue )
{
	if ( hDLL == NULL )
		return FALSE;

	return (*pPas1000DigitalIn)( wDeviceNo, pbDigitalInValue );
}
//-------------------------------------------------------------------
// 		fW^o͂̏
// 		wDeviceNo			ΏۃfoCX̃foCXʔԍ
//			bDigitalOutValue	fW^o̓f[^
// ߂l	 TRUE
//			s FALSE
//-------------------------------------------------------------------
BOOL Pas1000wDigitalOut( WORD wDeviceNo, BYTE bDigitalOutValue )
{
	if ( hDLL == NULL )
		return FALSE;

	return (*pPas1000DigitalOut)( wDeviceNo, bDigitalOutValue );
}
//-------------------------------------------------------------------
// 		A[̃NA
// 		wDeviceNo	ΏۃfoCX̃foCXʔԍ
//			dwNumCh		`lԍ
// ߂l	 TRUE
//			s FALSE
//-------------------------------------------------------------------
BOOL Pas1000wAlarmClear( WORD wDeviceNo, DWORD dwNumCh )
{
	if ( hDLL == NULL )
		return FALSE;

	return (*pPas1000AlarmClear)( wDeviceNo, dwNumCh );
}
//-------------------------------------------------------------------
// 		MO̊Jn
// 		wDeviceNo	ΏۃfoCX̃foCXʔԍ
//			dwStartMode	Jn[h
// ߂l	 TRUE
//			s FALSE
//-------------------------------------------------------------------
BOOL Pas1000wStartLogging( WORD wDeviceNo, DWORD dwStartMode )
{
	if ( hDLL == NULL )
		return FALSE;

	return (*pPas1000StartLogging)( wDeviceNo, dwStartMode );
}
//-------------------------------------------------------------------
// 		MO̒~
// 		wDeviceNo	ΏۃfoCX̃foCXʔԍ
// ߂l	 TRUE
//			s FALSE
//-------------------------------------------------------------------
BOOL Pas1000wStopLogging( WORD wDeviceNo )
{
	if ( hDLL == NULL )
		return FALSE;

	return (*pPas1000StopLogging)( wDeviceNo );
}
//-------------------------------------------------------------------
// 		`lʂ̃Xe[^X擾
// 		wDeviceNo			ΏۃfoCX̃foCXʔԍ
//			pdwHardNumData		n[hobt@̃MOf[^i[̈ւ̃|C^
//			pdwSoftNumData		\tgobt@̃MOf[^i[̈ւ̃|C^
//			pdwLoggingStatus	MOXe[^Xi[̈ւ̃|C^
//			pdwOverrunError		I[o[G[i[̈ւ̃|C^
// ߂l	 TRUE
//			s FALSE
//-------------------------------------------------------------------
BOOL Pas1000wGetStatus( WORD wDeviceNo, PDWORD pdwHardNumData, PDWORD pdwSoftNumData,
							PDWORD pdwLoggingStatus, PDWORD pdwOverrunError )
{
	if ( hDLL == NULL )
		return FALSE;

	return (*pPas1000GetStatus)( wDeviceNo, pdwHardNumData, pdwSoftNumData,
									pdwLoggingStatus, pdwOverrunError );
}
//-------------------------------------------------------------------
// 		`lƂ̃Xe[^X擾
// 		wDeviceNo	ΏۃfoCX̃foCXʔԍ
//			pChStatus	Xe[^Xi[̈ւ̃|C^
// ߂l	 TRUE
//			s FALSE
//-------------------------------------------------------------------
BOOL Pas1000wGetChStatus( WORD wDeviceNo, TCHSTATUS *pChStatus )
{
	if ( hDLL == NULL )
		return FALSE;

	return (*pPas1000GetChStatus)( wDeviceNo, pChStatus );
}
//-------------------------------------------------------------------
// 		MOf[^擾
// 		wDeviceNo	ΏۃfoCX̃foCXʔԍ
//			dwNumData	擾f[^
//			pbData		MOf[^i[̈ւ̃|C^
// ߂l	 TRUE
//			s FALSE
//-------------------------------------------------------------------
BOOL Pas1000wGetData( WORD wDeviceNo, DWORD dwNumData, PBYTE pbData )
{
	if ( hDLL == NULL )
		return FALSE;

	return (*pPas1000GetData)( wDeviceNo, dwNumData, pbData );
}
//-------------------------------------------------------------------
// 		G[R[h擾
// 		wDeviceNo	ΏۃfoCX̃foCXʔԍ
// ߂l	G[R[h
//-------------------------------------------------------------------
DWORD Pas1000wGetLastError( WORD wDeviceNo )
{
	if ( hDLL == NULL )
		return PAS1000_ERR_WRAPDLL;

	return (*pPas1000GetLastError)( wDeviceNo );
}
//-------------------------------------------------------------------
// 		DLLGNX|[g֐AhX̎擾
// 		
// ߂l	 TRUE
//			s FALSE
//-------------------------------------------------------------------
static BOOL Pas1000wGetDllExportFunc( void )
{
	pPas1000Initialize = GetProcAddress( hDLL, "Pas1000Initialize" );
	if ( pPas1000Initialize == NULL )
		return FALSE;
	pPas1000Create = GetProcAddress( hDLL, "Pas1000Create" );
	if ( pPas1000Create == NULL )
		return FALSE;
	pPas1000Close = GetProcAddress( hDLL, "Pas1000Close" );
	if ( pPas1000Close == NULL )
		return FALSE;
	pPas1000Terminate = GetProcAddress( hDLL, "Pas1000Terminate" );
	if ( pPas1000Terminate == NULL )
		return FALSE;
	pPas1000GetVersion = GetProcAddress( hDLL, "Pas1000GetVersion" );
	if ( pPas1000GetVersion == NULL )
		return FALSE;
	pPas1000GetDevInfo = GetProcAddress( hDLL, "Pas1000GetDevInfo" );
	if ( pPas1000GetDevInfo == NULL )
		return FALSE;
	pPas1000SetUnitId = GetProcAddress( hDLL, "Pas1000SetUnitId" );
	if ( pPas1000SetUnitId == NULL )
		return FALSE;
	pPas1000GetUnitInfo = GetProcAddress( hDLL, "Pas1000GetUnitInfo" );
	if ( pPas1000GetUnitInfo == NULL )
		return FALSE;
	pPas1000SetTime = GetProcAddress( hDLL, "Pas1000SetTime" );
	if ( pPas1000SetTime == NULL )
		return FALSE;
	pPas1000GetTime = GetProcAddress( hDLL, "Pas1000GetTime" );
	if ( pPas1000GetTime == NULL )
		return FALSE;
	pPas1000SetMode = GetProcAddress( hDLL, "Pas1000SetMode" );
	if ( pPas1000SetMode == NULL )
		return FALSE;
	pPas1000DigitalIn = GetProcAddress( hDLL, "Pas1000DigitalIn" );
	if ( pPas1000DigitalIn == NULL )
		return FALSE;
	pPas1000DigitalOut = GetProcAddress( hDLL, "Pas1000DigitalOut" );
	if ( pPas1000DigitalOut == NULL )
		return FALSE;
	pPas1000AlarmClear = GetProcAddress( hDLL, "Pas1000AlarmClear" );
	if ( pPas1000AlarmClear == NULL )
		return FALSE;
	pPas1000StartLogging = GetProcAddress( hDLL, "Pas1000StartLogging" );
	if ( pPas1000StartLogging == NULL )
		return FALSE;
	pPas1000StopLogging = GetProcAddress( hDLL, "Pas1000StopLogging" );
	if ( pPas1000StopLogging == NULL )
		return FALSE;
	pPas1000GetStatus = GetProcAddress( hDLL, "Pas1000GetStatus" );
	if ( pPas1000GetStatus == NULL )
		return FALSE;
	pPas1000GetChStatus = GetProcAddress( hDLL, "Pas1000GetChStatus" );
	if ( pPas1000GetChStatus == NULL )
		return FALSE;
	pPas1000GetData = GetProcAddress( hDLL, "Pas1000GetData" );
	if ( pPas1000GetData == NULL )
		return FALSE;
	pPas1000GetLastError = GetProcAddress( hDLL, "Pas1000GetLastError" );
	if ( pPas1000GetLastError == NULL )
		return FALSE;

	return TRUE;										// SĂDLLGNX|[g֐AhX擾
}
